Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/ClassificationModel.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/ClassificationModel.cs	(revision 5736)
+++ 	(revision )
@@ -1,51 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.IO;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Problems.DataAnalysis;
-using System.Drawing;
-
-namespace HeuristicLab.Problems.DataAnalysis {
-  /// <summary>
-  /// Represents a general classification model.
-  /// </summary>
-  [StorableClass]
-  [Item("ClassificationModel", "Represents a general classification model.")]
-  public abstract class ClassificationModel : DataAnalysisModel, IClassificationModel {
-    [StorableConstructor]
-    protected ClassificationModel(bool deserializing) : base(deserializing) { }
-    protected ClassificationModel(ClassificationModel original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public ClassificationModel()
-      : base() {
-    }
-
-    public abstract IEnumerable<double> GetEstimatedClassValues(Dataset dataset, IEnumerable<int> rows);
-  }
-}
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/ClusteringModel.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/ClusteringModel.cs	(revision 5736)
+++ 	(revision )
@@ -1,51 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.IO;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Problems.DataAnalysis;
-using System.Drawing;
-
-namespace HeuristicLab.Problems.DataAnalysis {
-  /// <summary>
-  /// Represents a general clustering model.
-  /// </summary>
-  [StorableClass]
-  [Item("ClusteringModel", "Represents a general clustering model.")]
-  public abstract class ClusteringModel : DataAnalysisModel, IClusteringModel {
-    [StorableConstructor]
-    protected ClusteringModel(bool deserializing) : base(deserializing) { }
-    protected ClusteringModel(ClusteringModel original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public ClusteringModel()
-      : base() {
-    }
-
-    public abstract IEnumerable<double> GetClusterValues(Dataset dataset, IEnumerable<int> rows);
-  }
-}
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/DataAnalysisModel.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/DataAnalysisModel.cs	(revision 5736)
+++ 	(revision )
@@ -1,60 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Collections.Generic;
-using System.Linq;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Operators;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Optimization;
-using System;
-using System.Drawing;
-
-namespace HeuristicLab.Problems.DataAnalysis {
-  /// <summary>
-  /// Abstract base class for data analysis models
-  /// </summary>
-  [StorableClass]
-  public abstract class DataAnalysisModel : NamedItem, IDataAnalysisModel {
-    private const string ModelResultName = "Model";
-    private const string ProblemDataResultName = "ProblemData";
-
-    public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Function; }
-    }
-
-    [StorableConstructor]
-    protected DataAnalysisModel(bool deserializing) : base(deserializing) { }
-    protected DataAnalysisModel(DataAnalysisModel original, Cloner cloner)
-      : base(original, cloner) {
-      name = original.Name;
-      description = original.Description;
-    }
-    public DataAnalysisModel()
-      : base() {
-      name = ItemName;
-      description = ItemDescription;
-    }
-  }
-}
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/RegressionModel.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/RegressionModel.cs	(revision 5736)
+++ 	(revision )
@@ -1,51 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.IO;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Problems.DataAnalysis;
-using System.Drawing;
-
-namespace HeuristicLab.Problems.DataAnalysis {
-  /// <summary>
-  /// Represents a general regression model.
-  /// </summary>
-  [StorableClass]
-  [Item("RegressionModel", "Represents a general regression model.")]
-  public abstract class RegressionModel : DataAnalysisModel, IRegressionModel {
-    [StorableConstructor]
-    protected RegressionModel(bool deserializing) : base(deserializing) { }
-    protected RegressionModel(RegressionModel original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public RegressionModel()
-      : base() {
-    }
-
-    public abstract IEnumerable<double> GetEstimatedValues(Dataset dataset, IEnumerable<int> rows);
-  }
-}