Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/Attributes/NonDiscoverableTypeAttribute.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/Attributes/NonDiscoverableTypeAttribute.cs	(revision 5741)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/Attributes/NonDiscoverableTypeAttribute.cs	(revision 5741)
@@ -0,0 +1,37 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.PluginInfrastructure {
+  /// <summary>
+  /// This attribute can be used to specify that a class is excluded from type discovery
+  /// </summary>
+  [AttributeUsage(AttributeTargets.Class)]
+  public sealed class NonDiscoverableTypeAttribute : System.Attribute {
+    /// <summary>
+    /// Initializes a new instance of <see cref="NonDiscoverableTypeAttribute"/>.
+    /// </summary>
+    public NonDiscoverableTypeAttribute()
+      : base() {
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/DefaultApplicationManager.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/DefaultApplicationManager.cs	(revision 5703)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/DefaultApplicationManager.cs	(revision 5741)
@@ -258,6 +258,12 @@
       return from t in assembly.GetTypes()
              where CheckTypeCompatibility(type, t)
-             where onlyInstantiable == false || (!t.IsAbstract && !t.IsInterface && !t.HasElementType)
+             where onlyInstantiable == false ||
+                (!t.IsAbstract && !t.IsInterface && !t.HasElementType)
+             where !IsNonDiscoverableType(t)
              select BuildType(t, type);
+    }
+
+    private static bool IsNonDiscoverableType(Type t) {
+      return t.GetCustomAttributes(typeof(NonDiscoverableTypeAttribute), false).Any();
     }
 
Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 5703)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 5741)
@@ -21,5 +21,6 @@
     </UpgradeBackupLocation>
     <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
-    <TargetFrameworkProfile></TargetFrameworkProfile>
+    <TargetFrameworkProfile>
+    </TargetFrameworkProfile>
     <PublishUrl>publish\</PublishUrl>
     <Install>true</Install>
@@ -213,4 +214,5 @@
     <Compile Include="Attributes\ApplicationAttribute.cs" />
     <Compile Include="Attributes\ContactInformationAttribute.cs" />
+    <Compile Include="Attributes\NonDiscoverableTypeAttribute.cs" />
     <Compile Include="Attributes\PluginAttribute.cs" />
     <Compile Include="Attributes\PluginDependencyAttribute.cs" />
Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/LightweightApplicationManager.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/LightweightApplicationManager.cs	(revision 5703)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/LightweightApplicationManager.cs	(revision 5741)
@@ -122,4 +122,5 @@
                where CheckTypeCompatibility(type, t)
                where onlyInstantiable == false || (!t.IsAbstract && !t.IsInterface && !t.HasElementType)
+               where !IsNonDiscoverableType(t)
                select BuildType(t, type);
       }
@@ -130,4 +131,8 @@
         return Enumerable.Empty<Type>();
       }
+    }
+
+    private static bool IsNonDiscoverableType(Type t) {
+      return t.GetCustomAttributes(typeof(NonDiscoverableTypeAttribute), false).Any();
     }
 