Index: branches/OKBJavaConnector/src/test/java/at/hl/okb/wsclient/OKBClientTest.java
===================================================================
--- branches/OKBJavaConnector/src/test/java/at/hl/okb/wsclient/OKBClientTest.java	(revision 5673)
+++ branches/OKBJavaConnector/src/test/java/at/hl/okb/wsclient/OKBClientTest.java	(revision 5761)
@@ -9,14 +9,9 @@
 import org.junit.Test;
 
-import at.hl.okb.wsclient.Exception.OKBWebServiceFailedException;
-import at.hl.wsclient.okb.AddAlgorithm;
-import at.hl.wsclient.okb.Algorithm;
-import at.hl.wsclient.okb.ArrayOfAlgorithm;
-import at.hl.wsclient.okb.ArrayOfDataType;
-import at.hl.wsclient.okb.DataType;
-import at.hl.wsclient.okb.IOKBService;
-import at.hl.wsclient.okb.OKBService;
-import at.hl.wsclient.okb.ObjectFactory;
-import at.hl.wsclient.okb.Platform;
+import com.heuristiclab.okb.wsclient.admin.AdministrationService;
+import com.heuristiclab.okb.wsclient.admin.Algorithm;
+import com.heuristiclab.okb.wsclient.admin.ArrayOfAlgorithm;
+import com.heuristiclab.okb.wsclient.admin.IAdministrationService;
+
 
 /**
@@ -26,6 +21,7 @@
 public class OKBClientTest {
 
-	OKBService srv = null;
-	IOKBService port = null;
+	
+	AdministrationService srv = null;
+	IAdministrationService port = null;
 
 	/**
@@ -48,6 +44,7 @@
 	@Before
 	public void setUp() throws Exception {
-		this.srv = new OKBService();
-		this.port = srv.getWSHttpBindingIOKBService1();
+		this.srv = new AdministrationService();
+		this.port = srv.getJavaAdministrationService(); //.getWSHttpBindingIAdministrationService1();
+		
 	}
 
@@ -58,31 +55,31 @@
 	public void tearDown() throws Exception {
 	}
-
-	@Test
-	public void AddAlgorithmTest() throws Exception {
-
-		ObjectFactory fac = new ObjectFactory();
-		AddAlgorithm addA = fac.createAddAlgorithm();
-		addA.setDto(fac.createAddAlgorithmDto(fac.createAlgorithm()));
-		Long retval = 0L;
-		
-//		if (port.getAlgorithm(2L)!=null)
-//			port.deleteAlgorithm(2L);
-		
-
-		Algorithm a = fac.createAlgorithm();
-		a.setAlgorithmClassId(1L);
-		a.setDescription(fac.createNamedOKBItemDescription("a new Algo"));
-		a.setId(2L);
-		a.setName(fac.createNamedOKBItemName("Algorithm Name 6"));
-		a.setPlatformId(1L);
-		try {
-			retval = port.addAlgorithm(a);
-		} catch (Exception e) {
-			throw new OKBWebServiceFailedException(e.getMessage());
-		}
-		assertTrue("Algortihm wasn't added", retval > 0);
-	}
-
+	
+//	@Test
+//	public void AddAlgorithmTest() throws Exception {
+//
+//		ObjectFactory fac = new ObjectFactory();
+//		AddAlgorithm addA = fac.createAddAlgorithm();
+//		addA.setDto(fac.createAddAlgorithmDto(fac.createAlgorithm()));
+//		Long retval = 0L;
+//		
+////		if (port.getAlgorithm(2L)!=null)
+////			port.deleteAlgorithm(2L);
+//		
+//
+//		Algorithm a = fac.createAlgorithm();
+//		a.setAlgorithmClassId(1L);
+//		a.setDescription(fac.createNamedOKBItemDescription("a new Algo"));
+//		a.setId(2L);
+//		a.setName(fac.createNamedOKBItemName("Algorithm Name 6"));
+//		a.setPlatformId(1L);
+//		try {
+//			retval = port.addAlgorithm(a);
+//		} catch (Exception e) {
+//			throw new OKBWebServiceFailedException(e.getMessage());
+//		}
+//		assertTrue("Algortihm wasn't added", retval > 0);
+//	}
+//
 	@Test
 	public void GetAlgorithmsTest() {
@@ -101,33 +98,33 @@
 		assertTrue("No Algorithms found!", algos.getAlgorithm().size() > 0);
 	}
-
-	@Test
-	public void GetDataTypesTest() {
-
-		ArrayOfDataType dataTypes = port.getDataTypes();
-
-		for (DataType dataType : dataTypes.getDataType()) {
-			System.out.println("algo Id:=" + dataType.getId());
-			System.out.println("algo platformId:=" + dataType.getPlatformId());
-			System.out.println("algo Name:=" + dataType.getName());
-			System.out.println("algo Class:=" + dataType.getClass());
-			System.out.println("algo SQLName:="
-					+ dataType.getSqlName().getValue());
-		}
-		assertTrue("No dataTypes found!", dataTypes.getDataType().size() > 0);
-	}
-
-	@Test
-	public void GetPlatFormTest() {
-		Platform f = port.getPlatform(1L);
-		assertTrue(f.getName().getValue().length() > 0);
-	}
-
-	OKBServiceClient client = new OKBServiceClient();
-
-	@Test
-	public void testGetPlatform() {
-		client.getPlatformId("ECJ");
-	}
+//
+//	@Test
+//	public void GetDataTypesTest() {
+//
+//		ArrayOfDataType dataTypes = port.getDataTypes();
+//
+//		for (DataType dataType : dataTypes.getDataType()) {
+//			System.out.println("algo Id:=" + dataType.getId());
+//			System.out.println("algo platformId:=" + dataType.getPlatformId());
+//			System.out.println("algo Name:=" + dataType.getName());
+//			System.out.println("algo Class:=" + dataType.getClass());
+//			System.out.println("algo SQLName:="
+//					+ dataType.getSqlName().getValue());
+//		}
+//		assertTrue("No dataTypes found!", dataTypes.getDataType().size() > 0);
+//	}
+//
+//	@Test
+//	public void GetPlatFormTest() {
+//		Platform f = port.getPlatform(1L);
+//		assertTrue(f.getName().getValue().length() > 0);
+//	}
+//
+//	AdministrationServiceClient client = new AdministrationServiceClient();
+//
+//	@Test
+//	public void testGetPlatform() {
+//		client.getPlatformId("ECJ");
+//	}
 	
 	