Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/HLWebPluginHost.csproj
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/HLWebPluginHost.csproj	(revision 5763)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/HLWebPluginHost.csproj	(revision 5764)
@@ -80,9 +80,4 @@
     <Compile Include="PluginLib\PluginViewEngine.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Service References\OKBAdministrationService\Reference.cs">
-      <AutoGen>True</AutoGen>
-      <DesignTime>True</DesignTime>
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </Compile>
   </ItemGroup>
   <ItemGroup>
@@ -95,26 +90,4 @@
     <Content Include="Global.asax" />
     <Content Include="Scripts\lbAlgorithmClassOnClick.js" />
-    <None Include="Service References\OKBAdministrationService\AdministrationService.disco" />
-    <None Include="Service References\OKBAdministrationService\configuration91.svcinfo" />
-    <None Include="Service References\OKBAdministrationService\configuration.svcinfo" />
-    <None Include="Service References\OKBAdministrationService\HLWebPluginHost.OKBAdministrationService.Algorithm.datasource">
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </None>
-    <None Include="Service References\OKBAdministrationService\HLWebPluginHost.OKBAdministrationService.AlgorithmClass.datasource">
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </None>
-    <None Include="Service References\OKBAdministrationService\HLWebPluginHost.OKBAdministrationService.Platform.datasource">
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </None>
-    <None Include="Service References\OKBAdministrationService\HLWebPluginHost.OKBAdministrationService.Problem.datasource">
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </None>
-    <None Include="Service References\OKBAdministrationService\HLWebPluginHost.OKBAdministrationService.ProblemClass.datasource">
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </None>
-    <None Include="Service References\OKBAdministrationService\Reference.svcmap">
-      <Generator>WCF Proxy Generator</Generator>
-      <LastGenOutput>Reference.cs</LastGenOutput>
-    </None>
     <Content Include="Views\ServicePrototype\Index.aspx" />
     <Content Include="Web.config">
@@ -151,14 +124,4 @@
     <Content Include="Views\Shared\Site.Master" />
     <Content Include="Views\Web.config" />
-    <None Include="Service References\OKBAdministrationService\AdministrationService.wsdl" />
-    <None Include="Service References\OKBAdministrationService\AdministrationService1.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\OKBAdministrationService\AdministrationService2.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\OKBAdministrationService\AdministrationService3.xsd">
-      <SubType>Designer</SubType>
-    </None>
   </ItemGroup>
   <ItemGroup>
@@ -168,12 +131,4 @@
   <ItemGroup>
     <WCFMetadata Include="Service References\" />
-  </ItemGroup>
-  <ItemGroup>
-    <WCFMetadataStorage Include="Service References\OKBAdministrationService\" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Service References\OKBAdministrationService\AdministrationService.xsd">
-      <SubType>Designer</SubType>
-    </None>
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Web.config
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Web.config	(revision 5763)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Web.config	(revision 5764)
@@ -124,5 +124,5 @@
               algorithmSuite="Default" />
           </security>
-        </binding>        
+        </binding>
       </wsHttpBinding>
     </bindings>
@@ -134,5 +134,5 @@
           <certificate encodedValue="AwAAAAEAAAAUAAAAwK1+2oAmcy/mI2P2QjyiJRh0y60gAAAAAQAAACoCAAAwggImMIIBj6ADAgECAhAIkseQ2EEhgU720qJA61gqMA0GCSqGSIb3DQEBBAUAMCQxIjAgBgNVBAMTGXNlcnZpY2VzLmhldXJpc3RpY2xhYi5jb20wHhcNMTAwNTExMTExNDAyWhcNMzkxMjMxMjM1OTU5WjAkMSIwIAYDVQQDExlzZXJ2aWNlcy5oZXVyaXN0aWNsYWIuY29tMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCq26Bwmwc7k+4W30qLQ2j+FInEL5BuH6opDY6CSlrtt3xQS/anrhvpbf3QghLDVINzcHkzbPmm/SguG4F85QLB6xO+tJaOvRo0iEK5g3c307vMIru7FJwk/OhplEQ5J1hbDgL3zOJlrWlgtqRVxCtVdF3XroI9BctOt1NkeKv9ewIDAQABo1kwVzBVBgNVHQEETjBMgBCjbgdYd4j5JgUuJ1Wo/GxroSYwJDEiMCAGA1UEAxMZc2VydmljZXMuaGV1cmlzdGljbGFiLmNvbYIQCJLHkNhBIYFO9tKiQOtYKjANBgkqhkiG9w0BAQQFAAOBgQAb/2xk2uQad68shSPl/uixWgvFI8WkxOTBopOLaLtDxwCeZ3mWVHdV9VnixHtThubnEBXAhYOCQSIXWtQuXFWO+gH3YyjTRJY5kTmXyuvBRTn3/so5SrQ7Rdlm9hf6E5YVX3tCjAy7ybUyaDUkQfmH5vmvgvpMzRfsJ1qhnUpJiQ==" />
         </identity>
-      </endpoint>      
+      </endpoint>
     </client>
   </system.serviceModel>